.\" @(#)sidentd.8 1.9 92/02/11 Lysator
.\" Copyright (c) 1992 Peter Eriksson, Lysator, Linkoping University.
.\" This software has been released into the public domain.
.\"
.TH SIDENTD 8 "27 May 1992"
.SH NAME
sidentd, in.sidentd \- TCP/IP S/IDENT protocol responder
.SH SYNOPSIS
.B /usr/sbin/in.sidentd
.RB [ \-o ]
.RB [ \-e ]
.RB [ \-l ]
.RB [ \-n ]
.RB [ \-V ]
.RB [ \-N ]
.RB [ \-T ]
.RB [ \-M ]
.RB [ \-C ]
.RB [ \-d ]

.SH DESCRIPTION
.IX "sidentd daemon" "" \fLsidentd\fP daemon"
.B sidentd
is a responder which implements the
.SM TCP/IP
proposed standard
.SM IDENT
user identification protocol as specified in the
.SM  draft-morgan-ident-ext-02.txt  
document.
.PP
.B sidentd
operates by looking up specific
.SM TCP/IP
connections and returning the request authetication information
for the process owning the connection.  In the current version 
this can either be the unix username or a SASL-style kerberos_v4 
authentication exchange.
.SH ARGUMENTS
The
.PP
The responder must be started by
.B inetd
whenever a new connection is requested.
.PP
The
.B \-V
flag makes
.B sidentd
display the version number and then exit.
.PP
The
.B \-l
flag tells
.B sidentd
to use the System logging daemon
.B syslogd
for logging purposes.
.PP
The
.B \-n
flag tells
.B sidentd
to return uids rather than usernames when allowing 
"trivial" authentication. See the 
.B \-T 
option. 
.PP
The
.B \-o
flag tells
.B sidentd
to not reveal the operating system type it is run on and to instead
always return "OTHER".
.PP
The
.B \-e
flag tells
.B sidentd
to always return "UNKNOWN-ERROR" instead of the "NO-USER" or
"INVALID-PORT" errors.
.PP
The
.B \-c<charset>
flags tells
.B sidentd
to add the optional (according to the IDENT protocol) character set
designator to the reply generated.
.I charset
should be a valid character set as described in the MIME RFC in upper
case characters. 
.PP
The
.B \-N
flag makes
.B sidentd
turn off the check for a file ".nosident" in each homedirectory for a user which the
daemon is about to return the user name for. If that file exists then the
daemon will give the error
.B HIDDEN-USER
instead of the normal USERID response.
.PP
The
.B \-d
flag enables some debugging code that normally should NOT
be enabled since that breaks the protocol and may reveal information
that should not be available to outsiders.
.PP
.B -T
enables sident to work as a regular ident responder as well as an sident
responder. It is off by default. 
.PP
.B -M
flags the 
.B sidentd 
responder to turn on the NO_MUTUAL_AUTH bit in the sident_flags 
vector. This signals the requestor that it does not need to 
do whatever mutual auth procedure specified by the authtype.
.PP
.B -C
flags the 
.B sidentd 
responder to turn on the SERVER_PORT macro check. This macro is
defined responder/identd.h and returns false if the port is the
port of a "well known service". This shortcuts the ident exchange
if the responder port is the port of a WKS. The default macro is
.nf
.ft B
	( port < 1024  || port == 6000 ) 
.ft R
.fi
Using this feature is highly recommended. It limits the ability of
random network machines to get information from your responder. 
.PP
.B kernelfile
defaults to the normally running kernel file.
.PP
.B kmemfile
defaults to the memory space of the normally running kernel.
.SH UNDOCUMENTED FLAGS
The
.B -v
flag enables more verbose output or messages. (Further occurences of the
.B -v
flag make things even more verbose.) Currently not used: ignored.
.PP

.SH INSTALLATION
.B sidentd
must be  invoked by the internet server (see
.BR inetd (8C)
) for requests to connect to the
.SM IDENT
port as indicated by the
.B /etc/services
file (see
.BR services (5)
) 

.SH EXAMPLES
Assuming the responder is located in
.B /usr/etc/in.sidentd
one can put :
.PP
ident stream tcp nowait root /usr/etc/in.sidentd in.sidentd -T -l -C 
.PP
into the
.B /etc/inetd.conf
file. If you are supporting "KERBEROS_V4" authentication the responder
must run as the "superuser" root. If you are using tcp-wrappers, you 
should run the responder as follows. 
.PP
ident stream tcp nowait root /usr/etc/tcpd /usr/etc/in.sidentd -T -l -C 
.PP
Running the responder under 
.Btcpd 
is HIGHLY recommended. The responder is
fairly resource intensive and can easily be subject to denial of service
attacks. 
.B tcpd 
provides a simple and fast switch to solve the problem. 
.SH NOTES
The username (or UID) returned ought to be the login name. However it
(probably, for most architecture implementations) is the "real user ID" as
stored with the process; there is no provision for returning the "effective
user ID". Thus the UID returned may be different from the login name for
setuid programs (or those running as root) which done a
.BR setuid (3)
call and their children. For example, it may (should?) be wrong for an
incoming
.B ftpd
; and we are probably interested in the running shell, not the
.B telnetd
for an incoming telnet session. (But of course
.B sidentd
returns info for outgoing connections, not incoming ones.)
.SH SEE ALSO
.BR authuser (3)
,
.BR inetd.conf (5)
.SH BUGS
The handling of fatal errors could be better.
